tclap: TCLAP::ValueArg< T > Class Template Reference

# TCLAP::ValueArg< T > Class Template Reference

The basic labeled argument that parses a value. More...

`#include <ValueArg.h>`

Inheritance diagram for TCLAP::ValueArg< T >:

List of all members.

## Public Member Functions
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, Visitor *v=NULL)
| Labeled ValueArg constructor.
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Labeled ValueArg constructor.
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Labeled ValueArg constructor.
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, Visitor *v=NULL)
| Labeled ValueArg constructor.
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument.
T & | getValue ()
| Returns the value of the argument.
virtual std::string | shortID (const std::string &val="val") const
| Specialization of shortID.
virtual std::string | longID (const std::string &val="val") const
| Specialization of longID.
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines.
## Protected Member Functions
void | _extractValue (const std::string &val)
| Extracts the value from the string.
## Protected Attributes
T | _value
| The value parsed from the command line.
T | _default
| Used to support the reset() method so that ValueArg can be reset to their constructed value.
std::string | _typeDesc
| A human readable description of the type to be parsed.
Constraint< T > * | _constraint
| A Constraint this Arg must conform to.

## Detailed Description

### template<class T>
class TCLAP::ValueArg< T >

The basic labeled argument that parses a value.

This is a template class, which means the type T defines the type that a given object will attempt to parse when the flag/name is matched on the command line. While there is nothing stopping you from creating an unflagged ValueArg, it is unwise and would cause significant problems. Instead use an UnlabeledValueArg.

Definition at line 43 of file ValueArg.h.

## Constructor & Destructor Documentation

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | const std::string & | typeDesc,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Labeled ValueArg constructor.

Constructor implementation.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | value | - The default value assigned to this argument if it is not present on the command line.
  | typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 252 of file ValueArg.h.

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Labeled ValueArg constructor.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | value | - The default value assigned to this argument if it is not present on the command line.
  | typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  | parser | - A CmdLine parser object to add this Arg to
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 267 of file ValueArg.h.

References TCLAP::CmdLineInterface::add().

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Labeled ValueArg constructor.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | value | - The default value assigned to this argument if it is not present on the command line.
  | constraint | - A pointer to a Constraint object used to constrain this Arg.
  | parser | - A CmdLine parser object to add this Arg to.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 300 of file ValueArg.h.

References TCLAP::CmdLineInterface::add().

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | Constraint< T > * | constraint,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Labeled ValueArg constructor.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | value | - The default value assigned to this argument if it is not present on the command line.
  | constraint | - A pointer to a Constraint object used to constrain this Arg.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 285 of file ValueArg.h.

## Member Function Documentation

template<class T >

void TCLAP::ValueArg< T >::_extractValue | ( | const std::string & | val | ) | `[inline, protected]`

Extracts the value from the string.

Attempts to parse string as type T, if this fails an exception is thrown.

Parameters:

  | val | - value to be parsed.

Definition at line 400 of file ValueArg.h.

References TCLAP::ValueArg< T >::_constraint, TCLAP::ValueArg< T >::_value, TCLAP::ArgException::error(), TCLAP::ExtractValue(), and TCLAP::Arg::toString().

Referenced by TCLAP::ValueArg< T >::processArg(), and TCLAP::UnlabeledValueArg< T >::processArg().

template<class T >

T & TCLAP::ValueArg< T >::getValue | ( |  | ) | `[inline]`

Returns the value of the argument.

Implementation of getValue().

Definition at line 322 of file ValueArg.h.

References TCLAP::ValueArg< T >::_value.

template<class T >

std::string TCLAP::ValueArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const`[inline, virtual]`

Specialization of longID.

Implementation of longID.

Parameters:

  | val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledValueArg< T >.

Definition at line 393 of file ValueArg.h.

References TCLAP::ValueArg< T >::_typeDesc.

template<class T >

bool TCLAP::ValueArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args |
| ) |  |  | `[inline, virtual]`

Handles the processing of the argument.

Implementation of processArg().

This re-implements the Arg version of this method to set the _value of the argument appropriately. It knows the difference between labeled and unlabeled.

Parameters:

  | i | - Pointer the the current argument in the list.
  | args | - Mutable list of strings. Passed in from main().

Implements TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledValueArg< T >.

Definition at line 328 of file ValueArg.h.

References TCLAP::Arg::_alreadySet, TCLAP::Arg::_checkWithVisitor(), TCLAP::ValueArg< T >::_extractValue(), TCLAP::Arg::_hasBlanks(), TCLAP::Arg::_ignoreable, TCLAP::Arg::_xorSet, TCLAP::Arg::argMatches(), TCLAP::Arg::delimiter(), TCLAP::Arg::ignoreRest(), TCLAP::Arg::toString(), and TCLAP::Arg::trimFlag().

template<class T >

void TCLAP::ValueArg< T >::reset | ( |  | ) | `[inline, virtual]`

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented from TCLAP::Arg.

Definition at line 417 of file ValueArg.h.

References TCLAP::ValueArg< T >::_default, and TCLAP::ValueArg< T >::_value.

template<class T >

std::string TCLAP::ValueArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const`[inline, virtual]`

Specialization of shortID.

Implementation of shortID.

Parameters:

  | val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledValueArg< T >.

Definition at line 383 of file ValueArg.h.

References TCLAP::ValueArg< T >::_typeDesc.

## Member Data Documentation

template<class T>

Constraint<T>* TCLAP::ValueArg< T >::_constraint`[protected]`

A Constraint this Arg must conform to.

Definition at line 72 of file ValueArg.h.

Referenced by TCLAP::ValueArg< T >::_extractValue().

template<class T>

T TCLAP::ValueArg< T >::_default`[protected]`

Used to support the reset() method so that ValueArg can be reset to their constructed value.

Definition at line 58 of file ValueArg.h.

Referenced by TCLAP::ValueArg< T >::reset().

template<class T>

std::string TCLAP::ValueArg< T >::_typeDesc`[protected]`

A human readable description of the type to be parsed.

This is a hack, plain and simple. Ideally we would use RTTI to return the name of type T, but until there is some sort of consistent support for human readable names, we are left to our own devices.

Definition at line 67 of file ValueArg.h.

Referenced by TCLAP::ValueArg< T >::longID(), TCLAP::UnlabeledValueArg< T >::longID(), TCLAP::ValueArg< T >::shortID(), and TCLAP::UnlabeledValueArg< T >::shortID().

template<class T>

T TCLAP::ValueArg< T >::_value`[protected]`

The value parsed from the command line.

Can be of any type, as long as the >> operator for the type is defined.

Definition at line 52 of file ValueArg.h.

Referenced by TCLAP::ValueArg< T >::_extractValue(), TCLAP::ValueArg< T >::getValue(), and TCLAP::ValueArg< T >::reset().

The documentation for this class was generated from the following file:

- ValueArg.h